<script setup lang="ts">
const props = withDefaults(
  defineProps<{
    imageId: string;
    height?: number;
  }>(),
  {
    height: 250,
  },
);

const { fetchImage } = useImageService();
const { data, error } = await useAsyncData(
  `image-${props.imageId}-${props.height}`,
  () => fetchImage(props.imageId, props.height),
);
const imageUrl = computed(() =>
  data.value ? URL.createObjectURL(data.value) : undefined,
);
</script>

<template>
  <client-only>
    <div class="d-inline-flex align-center text-center mr-1 flex-column">
      <v-img
        v-if="!error"
        class="flex-grow-1"
        :src="imageUrl"
        :height="props.height"
        :min-width="props.height"
      />
      <v-sheet
        v-else
        flat
        border
        color="secondary"
        :height="props.height"
        :width="props.height"
        class="d-flex align-center justify-center"
      >
        Failed to fetch image
      </v-sheet>
    </div>
  </client-only>
</template>
